/*
	Write by xempo 2014-2015
	Free under LGPL
*/

#include <qfontdatabase.h>
#include <qlineedit.h>
#include "genset.h"
#include "../rtdata/en/target/cfg.h"

#include "tabwdg.cpp"

extern void createBtns(QWidget *wdg, QPushButton **Btn, const char **btnCap, int btnCount,
	int wd, int yPos, const char **slot1, const int *pix);

GenSetting *genSetWdg;

const char listSet[]="GenSetting",
	orgFileList[]={ 1,2,3,4,5,6,7,1,1,0,1,0,1,0 };

GenSetting::GenSetting(QWidget *par, int *pms)
	: CfgWidget(par, listSet), utf8code(_setCodec(2)),
	tashCnt(0), tashPre(0),
	_Params(pms)
{
}

LVItem *GenSetting::subNodeCreat(LVItem *it, LVItem *after, const char *txt, const QPixmap *pix, const QPixmap *pix2, MAU *mau)
{
int D;
FastBlock lst;
lst.getFromMau(mau);
lst.memDiv(":,");
LVItem *ic, *sit=new LVItem(it, after, txt, utf8code);
sit->setType(after ? 2 : 1);
sit->setPixmap(0, *pix);
ic=NULL;
for(D=0; D<lst.count(); D++){
	ic=new LVItem(sit, ic, lst.lstIndex(D), utf8code);
	ic->setType(after ? 4:3);
	ic->setPixmap(0, *pix2);
	ic->setRenameEnabled(0,true);
	}
return sit;
}

inline void TabWdg::closing()
{
int i;
Filesan *fs=(Filesan *)(topLevelWidget()->parentWidget()), *_fs;
fs->setProgFonts(comboFont->currentText(), comboSize->currentText(),
	boldChk->isChecked(), italicChk->isChecked(), underlineChk->isChecked() );
fs->refreshList(dtfmtlst.lstIndex(__params[44]));
for(i=0; i<filesors.count(); i++){
     _fs=filesors.at(i);
     if(fs!=_fs){
	_fs->setProgFonts(comboFont->currentText(), comboSize->currentText(),
		boldChk->isChecked(), italicChk->isChecked(), underlineChk->isChecked() );
	_fs->refreshList(dtfmtlst.lstIndex(__params[44]));
	}
}
}

#define  delWarn  chkb[0]
#define  homeUse  chkb[1]
#define  fastHtmBrow  chkb[2]
#define  copyLog  chkb[3]
#define  moreShow  chkb[4]
#define  imgdbBtn  chkb[5]

void GenSetting::execu(const int w, const int h, const int id)
{
#define  LeftWide  64
#define  hg  23
	int t, j, B=18;
	CfgWidget::execu(w,h,id);
	creatGenTab()
	tab3=new TabWdg(tabwdg, 44);
	tab3->init(_cfg_+Int_feelview, tabw, fntSz, progFontId);
	QWidget *tab4=new QWidget(tabwdg);

	listSetInit(tab4, &optList, /*scaleRect(*/QRect(60, 26, 218, 228), &upBtn, &downBtn, colOptRslt);
	upBtn->setGeometry(LeftWide+218+18, 26+80, 2*hg, hg+8 );
	downBtn->setGeometry(LeftWide+218+18, 26+80+3*hg, 2*hg, hg+8 );

	tabwdg->addTab(tab4, *pixmapLoad(listSetImg), QString::fromUtf8(listset));

	lnkList=new ListContent(tab2, LnkTogListChs, T_LnkTogList, (Filesan *)parentWidget());
	lnkList->setSorting(-1);
	lnkList->addColumn(_Spc);
	lnkList->header()->hide();
	lnkList->setGeometry( B, B, tabw-2*B, tabh-fntSz-86 );
	connect(lnkList, sig_chsel, this, slot_chsel);
	connect(lnkList, sig_doRen, this, slot_doRen);

	static const char *__slots[3]={ SLOT(new()), SLOT(del()), SLOT(mdf())  };
	createBtns(tab2, __Btn, _cfg_+Int_addChs, 3, tabw, tabh-4*fntSz-8, __slots, NULL);

	if(FileAssoc){
	 int mode, n=0;
	 MAU mau[3];
	 LVItem *sit, *it=NULL;
	 j=-1;
	 nodCnt=FileAssoc->selfnumbs;	nodPre=nodCnt+6;
	 nodItems=(LnkNode *)zalloc(nodPre*sizeof(LnkNode));
	 while(n < nodCnt&&j<0xffff)
	    if( (mode=numbRead(FileAssoc, ++j, mau,3, false))>-1 ){
		nodItems[n++].num=j;
		it=new LVItem(lnkList, it, mau[2].buf, utf8code);
		it->setType(mode&ORL_OEM); // 8
		it->setPixmap(0, *pixmapLoad(mode&ORL_OEM ? itemOEMImg : itemGenImg));
		if((mode&ORL_OEM)==0)it->setRenameEnabled(0,true);
		it->setOpen(true);

		sit=subNodeCreat(it, NULL, progs, freqIco[ICO_EXEC_FILE], freqIco[ICO_EXEC_FILE], mau);
		subNodeCreat(it, sit, filters, pixmapLoad(filterImg), freqIco[ICO_NORM], mau+1);
		}
	 lnkList->setSelected(lnkList->firstChild(), true);
	}
	for(j=0; j<cfg_chkcnt; j++){
		chkb[j]=new QCheckBox(QString::fromUtf8(_cfg_[j+Int_delWarnChs]), tab1);
		chkb[j]->setChecked(_Params[j]);
		}

#define  headHeight  20
	move(parentWidget()->x()+(parentWidget()->width()-width())/2,
		parentWidget()->y()+(parentWidget()->height()-height())/2);

	int w1, combH, hSpc;
	w1=tabw-42;
	combH=inputH;
	hSpc=combH+6;
	t=25;
	for(j=0; j<cfg_chkcnt; j++)chkb[j]->setGeometry(t, headHeight+hSpc*j, w1, combH);

#undef  headHeight
	setIcon(*pixmapLoad(genSetImg));
	show();
}

QMetaObject *GenSetting::metaObj = 0;
static QMetaObjectCleanUp cleanUp_GenSetting( listSet, &GenSetting::staticMetaObject );
QMetaObject* GenSetting::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "Up()" , &slot_0_0, QMetaData::Private },
	{ "Down()" , &slot_0_0, QMetaData::Private },
	{ "dtfmtSel()", &slot_0_0, QMetaData::Private },
	{ sure , &slot_0_0, QMetaData::Private },
	{ "chSel()" , &slot_0_0, QMetaData::Private }, //4 
	{ "doRen()" , &slot_ptr, QMetaData::Private }, 

	{ "new()", &slot_0_0, QMetaData::Private }, // 6
	{ "mdf()" , &slot_0_0, QMetaData::Private },
	{ "del()" , &slot_0_0, QMetaData::Private },
	{ "orgStyle()", &slot_0_0, QMetaData::Private },
	{ fastKey , &slot_int, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(listSet, CfgWidget::staticMetaObject(), slot_tbl, 11,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_GenSetting.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool GenSetting::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool GenSetting::qt_invoke( int _id, QUObject* _o )
{
int i, sw=_id - staticMetaObject()->slotOffset();
LVItem *it;
switch(sw){
case 0 :
case 1 : // Up
	moveListSet(optList, colOptRslt, sw);
	break;
case 2 :   tab3->changddtt();
	break;
case 3 :  // Sure (Ok-button)
	getListOpts(optList, colOptRslt+colOptCnt);
	for(i=0; i<cfg_chkcnt; i++)_Params[i]=chkb[i]->isChecked();
	if(FileAssoc){
		QListViewItem *sit;
		for(i=0; i<nodCnt; i++)if(nodItems[i].mdf){
		QCString s, s1;
		MAU mau[3];
		memset(mau, 0, sizeof(MAU)*3);
		it=lnkList->Index(i);
		sit=it->firstChild()->firstChild();
		while(sit){ s+=sit->text(0).utf8()+":"; sit=sit->nextSibling(); }
		mau->buf=(char *)(const char *)s;	mau->len=s.length()-1;
		sit=it->firstChild()->nextSibling()->firstChild();
		while(sit){ s1+=sit->text(0).utf8()+","; sit=sit->nextSibling(); }
		mau[1].buf=(char *)(const char *)s1;	mau[1].len=s1.length()-1;
		mau[2].buf=strdup(it->text(0).utf8());	// mau[2].len=0;
//		for(int j=0; j<3; j++)mau[j].alen=0;
		numbWrite(FileAssoc, nodItems[i].num<0 ? NumLast(FileAssoc) : nodItems[i].num, mau, 3);
		free(mau[2].buf);
		}
		for(i=0; i<tashCnt; i++)NumDel(FileAssoc, tash[i].num);
	}
	tab3->closing();
	close();
	break;
case 4 : { // chSel
	it=(LVItem *)lnkList->currentItem();
	i=it->getType();
	bool b=(i!=1&&i!=2)&&(i&8)!=8;
	for(i=1;i<3;i++)__Btn[i]->setEnabled(b);
	}
	break;
case 5 : it=(LVItem *)lnkList->currentItem();
	while(it->parent())it=(LVItem *)it->parent();
	nodItems[listViewIndex(lnkList, it) ].mdf=true;
	break;
case 8 : {
	LVItem *pIt;
	it=(LVItem *)lnkList->currentItem();
	if(it->getType()==0){
	    i=listViewIndex(lnkList, it);
		if(nodItems[i].num>-1){
		// NumDel(FileAssoc,  nodItems[i].num);
		  if(tashCnt>=tashPre){
			tashPre+=6;
			LnkNode *tmp=(LnkNode *)zalloc(sizeof(LnkNode)*tashPre);
			if(tashCnt){
				memcmp(tmp, tash, sizeof(LnkNode)*tashCnt);	
				free(tash);
			}
			tash=tmp;
		  }
		  tash[tashCnt++]=nodItems[i];
		  if(nodCnt-i>1)memmove(nodItems+i, nodItems+i+1, sizeof(LnkNode)*(nodCnt-i-1));
		  nodCnt--;
		}
	    lnkList->takeItem(it);
	}
	else {
		pIt=it;
		while( pIt->parent() )pIt=(LVItem *)pIt->parent();
		i=listViewIndex(lnkList, pIt);
		nodItems[i].mdf=true;
		it->parent()->takeItem(it);
		}
	((Filesan *)parentWidget())->delLVItem(it);
	}
	break;
case 7 :	lnkList->currentItem()->startRename(0); // mdf
	break;
case 6 : {
	LVItem *sit;
	it=(LVItem *)lnkList->currentItem();
	i=it->getType()&7;
	switch(i){
	case 0 : it=new LVItem(lnkList, lnkList->Index(nodCnt-1), "project1");
		it->setPixmap(0,*pixmapLoad(itemGenImg));
		it->setRenameEnabled(0,true);
		sit=new LVItem(it, NULL, progs);
		sit->setType(1);
		sit->setPixmap(0, *freqIco[ICO_EXEC_FILE]);
		sit->setRenameEnabled(0,true);
		sit=new LVItem(it, sit, filters);
		sit->setType(2);
		sit->setPixmap(0,*pixmapLoad(filterImg));
		sit->setRenameEnabled(0,true);
		lnkList->ensureItemVisible(it);
		it->setOpen(true);
		it->startRename(0);
		if(nodCnt>=nodPre){
			nodPre+=6;
			LnkNode *tmp=(LnkNode *)zalloc(sizeof(LnkNode)*nodPre);
			if(nodCnt>0){
				memcmp(tmp, nodItems, sizeof(LnkNode)*nodCnt);	
				free(nodItems);
			}
			nodItems=tmp;
			}
		nodItems[nodCnt].num=-1; // append
		nodItems[nodCnt].mdf=true;
		nodCnt++;
		break;
	case 1 : 
	case 2 : sit=new LVItem(it, NULL, i!=1 ? "*.*" : "prog1");
		sit->setType(i+2);
		goto _skp_;
	case 3 :
	case 4 : sit=new LVItem((LVItem *)it->parent(), it, i!=3 ? "*.*" : "prog1");
		sit->setType(i);
	_skp_:	sit->setRenameEnabled(0,true);
		sit->setPixmap(0, *freqIco[ i&1 ? ICO_EXEC_FILE :  ICO_NORM] );
		sit->startRename(0);
//		break;
	}
	}
	break;
case 10 : switch(_o[1].payload.i){
	case 600 : loadSearchModify((Filesan *)parentWidget());
		break;
	case 601 : ((Filesan *)parentWidget())->showTop();
/*		break;
	case 602 : help();
*/
	}
	break;
default : return CfgWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

GenSetting::~GenSetting()
{
if(tashCnt)free(tash);
free(nodItems);
genSetWdg=NULL;
}
