/*
	Write by xempo Nov 2015
	Free under LGPL
*/

#include "_fastblock.h"

_FastBlock :: _FastBlock(int m, int limit) :
	mode(m), lmt(limit),
	len(0), alen(0),	opm(0),	buf(NULL),
	cnt(0), mcnt(0),	list(NULL)
{
}

_FastBlock :: ~_FastBlock()
{
_resetMem(NULL);
}

/*void _FastBlock::virfun(int idx)
{
}*/

void _FastBlock::_resetMem(char *dat, const char *divfmt)
{
if(mode!=AllNoFree){
	if(list)free(list);
	if(buf&&mode!=NoFree)free(buf);
}

opm=0; mcnt=0;
list=NULL;
if( (buf=dat) ){
	len=strlen(dat);	alen=len;
//	if(lmt>OnlyAdd)
		cnt=1;
	_memDiv(divfmt);
	}
else {
	len=0;	alen=0;	cnt=0;
	}

}

int _FastBlock::_memDiv(const char *fmt) // 之所以另写一个，是因为要与Add和Rem配套
{
if(len){
  unsigned int n=1, ln, chr;
  bool msg=(opm&&cnt);
  register  unsigned int i;
  if(buf[len-1])len++;
  ln=len-1;
  if(mode>OnlyAdd && fmt==NULL )goto fast_jmp;
  if( msg ){	i=opm-1; 	n=cnt; 	}
  else {	i=0;	cnt=1;	}
  while( i<ln ){
	chr=buf[i];
	if( fmt&&strchr(fmt, chr ) || chr<2 ){ // unsigned, don't change
	buf[i]=0;
	if(cnt>=lmt){ len=i+1; ln=i;	break;	}
	cnt++;
	}
	i++;
  }

fast_jmp:  i=0;
  if(mcnt<cnt+1){
	if(list)free(list);
	n=1;
	mcnt=cnt+( mode>OnlyAdd ? 1 : 12);
	list=(char **)malloc(mcnt*sizeof(char **));
  }
  else if(msg)i=opm-1;

  for(*list=buf; i<ln; i++)
	  if(buf[i]==0)list[n++]=buf+i+1;
	list[cnt]=NULL;

  opm=0;
}
return cnt;
}

enum allocStyle { OldMach=320, OldMach_AppenAlone=1024 }; //, NewMach=1024, NewMach_AppenAlone=4096 };
int _FastBlock::add(const char *txt, const char *div) // return insert pos
{
 int txtLen=strlen(txt);
 if(txtLen){
   int I, idx, hd, ln;
   char *tmp, *pt;
   if(mode<CombList){// OnlyAdd 在 filesor BrwLst中可重复
	idx=0;
	while(idx<cnt&&strcmp(txt,list[idx]))idx++;
	if(idx<cnt){
//		if(lmt==InThread/*0x7ffffff6*/)return -1; /* 在线程中比较是否重发了 */
//		if(cnt==1)return 0;
		if(txt>=buf && txt<buf+len){
			char  temp[txtLen+2];
			for(I=0; I<txtLen; I++)temp[I]=txt[I];
			_rem(idx);
			for(I=0; I<txtLen; I++)buf[len+I]=temp[I];
			list[cnt]=buf+len;	
			len+=txtLen+1; // above because MAU fast to save
			return cnt++;
		}
		_rem(idx);
		idx=cnt;  // append last
		}
	}
   else {
	if(mode==CombList&&cnt>0&&strcmp(txt, list[cnt-1])==0)return -1;
	idx=cnt;
	}
   hd=0;
   if(cnt>=lmt){
	if(idx==cnt)idx--;
	while(buf[hd])hd++; hd++;// 删去头一串
	}
   ln=len-hd;
   if(alen<txtLen+ln+3){
	alen=txtLen+ln+ (mode<__AppenAlone ? (mode<OnlyAdd ? OldMach:OldMach_AppenAlone) : (mode < AppenAlone ? 1024 : 16384 ) );// 减少内存碎片
	tmp= (char *)malloc(alen);
	}
   else { tmp=buf;
	if(hd==0){ I=len;	opm=len; goto cpy; }
	}
   I=0;	opm=0;
   while( hd<len )tmp[I++]=buf[hd++];
  cpy:    pt=tmp+I;
   while( (*pt++ = *txt++) ); //strcpy(tmp+I, txt);
   if(tmp!=buf){	if(buf)free(buf); buf=tmp;	}
   len=ln+txtLen+1;
   if(mode<__AppenAlone) // 优化filesor的运行
	_memDiv(div);
   else cnt++;
   return idx;
   }
return -1;
}

/*void _FastBlock::fastDiv() // maybe use
{
  ln=len-1; i=0; n=0; L=0;
  for(*list=buf; i<ln; i++)
	  if(buf[i]==0)list[L++]=buf+i+1;
  list[cnt]=NULL;
}*/

void _FastBlock::_rem(int idx)
{
if(idx<cnt){
 char *pt=list[idx];
 int L=strlen(pt);
 len-=L+1;
 if(idx < --cnt){
    int ln, i=0;
    while( buf+i != pt ) i++;
    ln=len-i;
    for(i=0; i<ln; i++)pt[i]=pt[i+L+1];
//  memmove(pt, pt+L+1, );
    _memDiv(NULL);
//  sort(sortTag);
 }
}
}
