/*
    林江华编写，2010年2月，
    Copyright LinJiangHua 2010-2015
    Free under LGPL
*/

#include <qapplication.h>
#include "Fophonix.h"
#include "orlio.h"
#include "conspace.h"
#include "init.h"
#include "write.h"
#include "rebuild.h"

#include "options.h"
#include "filesan.h"
#include "xfun.h"
#include "Fophonix.h"
#include "orlcon.h"
#include "orlattr.h"
#include "infor.h"
#include "../rtdata/en/target/filesor.h"

#include "actmenu.cpp"

extern void (*pChMT)(__ORD *, int msg);

extern QStringList smLogList; // searchmodify.cpp

__ORL *orllib;

StrList pathList;

int langIdx=98, fontHeight,
	screenWidth, screenHeight;

const char langDir[]="Language", langEnv[]="LANG", Descript[]="descript",	listdir[]="List",
	nORL[]="Fophonix-1.0.4", dORL[]=".Fophonix-1.0.4";

const char *Fophonixcwd, *_homeUnder, *_homeName,
	 **p_countChs=(const char **)listdir;
QApplication *qApp;

static void *_numbRead(int id, int sz)
{
MAU mau;
if(numbRead(ORLRoot, id, &mau, 1, false)>-1)return mau.buf;
else return zalloc(sz*menulst.limit());
}

void sortTagsList(int sort)
{
FastBlock lst(tagNamlst);
int i=0, cn=lst.memDiv(NULL);
char *pts[cn];
tagNamlst.sort(sort>0, __params[58]/* case */);
while(i < cn)pts[i++]=taglst.lstIndex( lst.find(tagNamlst.lstIndex(i)) );
taglst.setPlist(pts);
}

int main(int argc, char **argv)
{
uId=getuid();
gId=getgid();
pcwd=getenv("PWD");
home=getenv("HOME"); // if(home==gettatic ); static !!
QApplication app(argc, argv);
qApp=&app;
int n, rt=1;
char *pt;
_homeUnder=strdup(home);
pt=strrchr((char *)_homeUnder, '/');
_homeName=pt+1;
if(pt!=_homeUnder)*pt=0;
else _homeUnder="/";
popMsg=popInfo;
msgShow=showMess;
getMsg=getMess;
PrnTxt=outText;
consWrite=writeCon;
extDest=menuPlusDo;
pChMT=getDirNam;
Filesan *filesor=new Filesan(NULL, init(&argc, argv, "--lang")); // use new because construct with WidgetFlags=...|Qt::WDestructiveClose	
orlX=filesor;
pt=(char *)orfn(nORL, dORL, "/usr/share/Fophonix-1.0.4", &rt, &Fophonixcwd);
if(rt>ini_first){
	char buf[320];
	sprintf(buf, pInfo, pt );
	infoWidget(buf, NULL, -1, filesor);
	return rt;
}
	
orllib=ORLspac(pt, (OpenSpace)(OpenAlway|HasFullPath|FastBuf), -1);
if(orllib==NULL){
    infoWidget(catstr(pt, "Unknow the file format !", '\n'), NULL, -1, NULL);
    return ini_notorl;
}

// free(pt); becasue (msg|HasFullPath), lib->fname=pt;
screenHeight=QApplication::desktop()->size().height();
screenWidth=QApplication::desktop()->size().width();
  MAU mau;
  __ORD *list;
  static char dfLang[4]={ 'e', 'n', 0, '0' }; //  "en\00";
  ORLRoot=(__ORD *)orllib;
  numbRead(ORLRoot, colOptId, &mau, 1, true);
  colOptRslt=mau.buf;
   numbRead(ORLRoot, 0, &mau, 1, true);
   __params=(int *)mau.buf;

  {
  char buf[128],  *dnam=NULL;
#define mu1  6
#define inv1  5
	static const char *mu1chs[mu1]={ "-C", "-P", "-T", "-R", "-N", "-H" },
	*_mu1chs[mu1]={ "--computer", "--place", "--tag",  "--Rose", "--nopanel", "--help" };
	int mu1val[mu1];
	static const int mu1inv[inv1]={ 0, 1, 2, 3, 4 }; // "--computer", "--place", "--tag",  "--star", "--nopanel" can't use togetther

#define  mu2  2
#define inv2  0
	static const char *mu2chs[mu2]={"-L", "-F" },*_mu2chs[mu2]={ "--language", "--filter" };
	int mu2val[mu2];

 memset(mu1val, 0, sizeof(int)*mu1);
 memset(mu2val, 0, sizeof(int)*mu2);
 ProcOpt opt1={	mu1,	mu1chs, _mu1chs,	mu1val,	inv1, mu1inv, 0	},
	opt2={	mu2,	mu2chs, _mu2chs,	mu2val,	inv2, NULL, 0	};
  const char  *txt=NULL;
  arglists *lst=procParas(argc-1, argv+1, &opt1, &opt2);
  bool hlp=false;
  if(lst){
     int i, a;
     if(lst->argc>0)dnam=(char *)lst->argv[lst->argc-1];
     for(i=0; i<opt1.argc; i++)
	if(opt1.rtval[i]){
		switch(i){
		case 5 : hlp=true;
			break;
//		case 6 :
		default : __params[48]=i; //filesor->setModul(i); pms_multPanel
		}
	}
     for(i=0; i<opt2.argc; i++)
        if( (a=opt2.rtval[i]&0x7fff) )
	switch(i){
	case 0 : txt=(char *)lst->subarg->argv[0];
		break;
	case 1 : filesor->setFilter(strdup(lst->subarg->argv[1]));
//	case 2 :  argv[a+1];
	}
     argsFree(lst);
   }
   if(txt)n=-1;
   else {
      n=numbRead(ORLRoot, languageId, &mau, 1, false);
      if(n>-1)txt=mau.buf;
      else {
	char *chs=getenv(langEnv);
	if(chs){
		int t;
		for( t=0; chs[t]!='.'&&chs[t]; t++)buf[t]=chs[t];
		buf[t]=0;	buf[t+1]='0';
		txt=buf;
		langIdx=0;
	}
	else txt=dfLang;
	}
   }

_re_cat_:   pt=catstr(langDir, txt, '/');
   selfDir=_diropen(ORLRoot, pt);
   free(pt);
   if(n>-1)free( (void *)txt );
   if(selfDir==NULL&&txt!=dfLang){
	txt=dfLang;
	goto _re_cat_;
	}
   if(numbRead(ORLRoot, passwdFile, &mau, 1, true)>-1) {
	usrList=getLogors(mau.buf, &usrIDs);
	free(mau.buf);
   }
   if(numbRead(ORLRoot, groupFile, &mau, 1, true)>-1) {
	grpList=getLogors(mau.buf, &groupIDs);
	free(mau.buf);
   }

   if(list=_diropen(ORLRoot, listdir)){
	numbRead(list, 0, &mau, 1, true);
	pt=mau.buf; // list limit
	for(n=0; n<ListCount; n++){
		_List[n].setLimit(pt[n]);
		if(numbRead(list, n+1, &mau, 1, false)>-1){
			_List[n].getFromMau(&mau);
			_List[n].memDiv(NULL);
			if(n==20)_List[20].setMode(CombList); // orlZone
	}
	}
	ORDclose(list,0);
	free(pt); // list limit
	if(taglst.count()==0){
		taglst.add(home);
		tagNamlst.add("Home");
		}
	}

//  get Env of  **argv
{
  int len, ln, b, t;
  char *src, *pth, *pt;
  if( (pt=strrchr( *argv, '/'))!=NULL &&pt != *argv ){
	*pt=0;
	envpaths.add(*argv);
	}
  n=0;
  while( n<envpaths.count() /* use dyn */){
     if( (pt=strstr(src=envpaths.lstIndex(n), "$(" )) !=NULL ){
         len=strlen(src);
         ln=len-(pt-src);
         for(b=0;pt[b]!=')'&&b<ln; b++);
         if(b<ln){
	char keyword[b+2];
	b-=2;
	for(t=0; t<b; t++)keyword[t]=pt[2+t];
	keyword[b]=0;
	pth=getenv(keyword);
	if(pth){
	  ln=strlen(pth);
	  char dat[ len+ln-b+2 ];
	  strcpy(dat,src);
	  len=pt-src;
	  strcpy(dat+len,pth);
	  strcpy(dat+len+ln,pt+b+3);
	  envpaths.rem(n);
	  fmtinp(dat+1, NULL, "/", '/');
	  envpaths.add(dat);	
	}
	}
     }
      n++;
  }
/* --------------- sys-path -------------*/
  pth=strdup(getenv("PATH"));
  fmtinp(pth+1, NULL, "/", '/');
  FastBlock tmp(pth,":,");
  for(t=0; t<tmp.count(); t++)envpaths.add(tmp.lstIndex(t));
/* ------------- can't optiom -------------- */
  envpaths.add(home);
  envpaths.add(pcwd);
  envpaths.setStrList(&pathList);
}
// ------------------------------ get Env(argv)  end------------------------------

   iconDir=_diropen(ORLRoot, "icons");
   for(n=0; n<freqIcons; n++)
	freqIco[n]=new QPixmap(*pixmapLoad(fileImg+n));

   _filesor_=charsFromORL(0);
   colName=_filesor_+Int_columnName;
   p_countChs=_filesor_+Int_countChs;
   cpListCols=_filesor_+Int_cpVList;
   if( __params[11]/*pms_sorttag*/)sortTagsList(__params[11]);

   descript=_diropen(selfDir, Descript);
   filesor->exec(dnam);
   if(hlp)ORLLink(filesor, 10, 2/* newWidget */);
  }
  menuFilesPos=(file_pos *)_numbRead(filesPosId, sizeof(file_pos));
  menuWdgsSiz=(file_pos *)_numbRead(proEditSizeId, sizeof(file_pos));
  menuIsMaxs=(char *)_numbRead(isMaxId, 2);
  FileAssoc=_diropen(selfDir,"FileAssoc");
  app.connect(&app, SIGNAL(lastWindowClosed()), &app, SLOT( quit() ) );
  rt=app.exec();
  mau.buf=(char *)__params;	mau.len=fs_params_count*sizeof(int); mau.alen=0;
  numbWrite(ORLRoot, paramsId, &mau, 1);
  n=menulst.limit();
  mau.buf=(char *)menuFilesPos;	mau.len=n*sizeof(file_pos);
  numbWrite(ORLRoot, filesPosId, &mau, 1);
  mau.buf=(char *)menuWdgsSiz;	// mau.len=n*sizeof(file_pos);
  numbWrite(ORLRoot, proEditSizeId, &mau, 1);
  mau.buf=(char *)menuIsMaxs;	mau.len=n*2; // one : isMax, other : _codec
  numbWrite(ORLRoot, isMaxId, &mau, 1);
  list=_diropen(ORLRoot, listdir);
  static const int preLens[ListCount-3]={ 400,400,160,160,400,300,250,250,320,80,160,160,80,160,120,120,400,300,400,300, 400,400, 400  };
  for(n=3; n<ListCount; n++){
	if(_List[n].count()==0)NumDel(list, n+1);
	else {
		_List[n].setMau(&mau);
		mauAlen(mau, preLens[n-3], 80);
		numbWrite(list, n+1, &mau, 1);
	}
  }
//	ORDclose(list, 0);	ORDclose(descript, 0);	ORDclose(FileAssoc, 0);	ORDclose(selfDir, 0);
  if(copyInfoList.count())saveLog(catstr(Fophonixcwd, "cpError.log", '/'), copyInfoList);
  if(smLogList.count())saveLog(catstr(Fophonixcwd, "searchmdf.log",'/'), smLogList);
  for(n=LASTSPACE; n>-1; n--)if(workspace[n])ORLclose(workspace[n], ORLrebuild);
  if(sysCmdId>-1){
	static const char syscmd[2][7]={ "reboot", "halt" },
	*syspms[2]={NULL, "-p" },
	sysMsg[2][22]={ "Can't restart system", "Can't shutdown system"};
	execlp(syscmd[sysCmdId], syscmd[sysCmdId], syspms[sysCmdId], NULL );
	CHBinfo(-1, sysMsg[sysCmdId]);
	}
  return 0;
}
