/*
    林江华编写，2010-2月，Copyright LinJiangHua
    Free under LGPL 2-2010
   email: xempo@189.cn
*/

#ifndef    FILESAN
#define    FILESAN

#include <signal.h>
#include <fcntl.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qlabel.h>
#include <qheader.h>
#include <sys/errno.h>
#include <qmetaobject.h>
#include <private/qucomextra_p.h>
#include <qtextcodec.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qsplitter.h>
#include "stdfun.h"
#include "helpwdg.h"
#include "imagefileview.h"
#include "treeview.h"
#include "combo.h"
#include "libnorm.h"
#include "cfun.h"
#include "actmenu.h"
#include "proedit.h"
#include "copy.h"
#include "basewidget.h"
#include "xfun.h"

#define  arCnt  4

extern const QUMethod  slot_ptr, slot_int, slot_0_0;

enum fun_num {
	SelectAsSource=5, SelectAction=36, ChangItem=37, IcoViewMous=38,
	DbClick=39, KeyEnter=40, exeOpen=41, exeOpens=42
	};

#include "fsloop.def"

#define	ReadComm(msg)	((msg&~COMBENTER) & 0xffff)

class CopyPanel;
class QToolButton;
class SearchModify;
class ORLcon;

extern CopyPanel *cpThrPanel;

struct dirpost_params {
const char *dnam;
const QPixmap *pix;
int est;
};

struct movepost_params
{
const char *src;
bool isDir;
int info, mvdup;
};

#define  operaMenu  topMenu[0]
#define  tagMenu  topMenu[1]
#define  confMenu  topMenu[2]
#define  personMenu  topMenu[3]
#define  operaSrcMenu  topMenu[4]
#define  codecMenu  topMenu[5]
#define  summaryMenu  topMenu[6]

#define  lineCnt  3
class Filesan : public QMainWindow
{
friend class TreeView;
friend class CopyThread;
friend void *subExpand(void *);
 moc_Object

public:
Filesan(QWidget *parent, int initRt);
// ~Filesan();
void showTop();
void exec(char *dnam);
int getItemAttrib(bool isViewOpera, bool sub);
void popRightMenu(void *it, bool isView);

void ORLrightmenu(void *it, bool isView);

void updateFophonix(bool isComb);

char *itemFullPath(const void *ico);
void setObjsStat(int tag, bool isView);
void setCopyStats(const char *chs);
int doProEdit(const char *pt, bool mult, int pos=0, const char *fun=NULL);

void popORLcons(const char *fnam);

void refreshList(const char *fmt);
void chFattrib(struct fAttribRslt *fr);
void imageInfo();
void treeUpdateObjs(char *pth);

void processImage(const char *pth, FastBlock *file_lst, ListOptions *f_mode);

LVItem *getItem(const char *);
void ORL_infor(__ORD *);

void busiedCursor();
void normalCursor();

void addTag(const char *dn);

void setNotifyTimer(siginfo_t *siginfo); // inline

QString _toUnicode(const char *txt) const
	{ return vStrCodec->toUnicode(txt); }

SearchModify *getSMW() const
{ return search_mdf_wdg; }

void setSMW(SearchModify *w){ search_mdf_wdg=w; }

void browNumb(ORLcon *wdg); // inline for proEdit

void openSelect(const char *pth, const char *nam);

void setFilter(const char *f){ Filter=f; }

int getModul() const
{ return modul; }

StatusPanel *stBar() const
{ return bottomPanel; }

int dirsCount() const
{ return vDirCnt; }

char *getDirNam() const
{ return dirNam; }

TreeView *getTreeView() const
{ return treeview; }

void setLib(__ORL *orl);

void showMountInfo(LVItem *it);

FastBlock *getFSels()
{ return &fsels; }

FastBlock *getIdSels()
{
return &Idsels;
}

void selectAsSrc(FastBlock &lst, bool add);
void execProg(int sw, FastBlock *sel, int idx);

void bwResize(BaseWidget *bw);

void delLVItem(LVItem *it, int val=1);

void ORLsettime(int v){ ORLtm=v; }

void setProgFonts(const QString &fn, const char *sz, bool bold, bool italic, bool underline);

inline void newText(const char *pth);

inline void setORLcons(ORLcon *p)
{
orlZone=p;
orlX=p;
}

void addNumb(__ORD *pdir, BYTE *unit, bool SH/* show hide */);

void seekPath(const char *pth);

void fsKillTimer();
void fsStartTimer(){ if(prgTmId==0)prgTmId=startTimer(500); }

void objsUpdate();

int getCDM() const
{ return CurDirMode; }

void clearView();

ActMenu *getTagMenu() const
{
return tagMenu;
}

void setDragDel(bool b){ dragDel=b; }

void PEAct();

void closeNotify();
void dirNotify(const char *dnam); /* dirNotify setup */

protected:
bool event( QEvent *e );
virtual void customEvent(QCustomEvent *);

private:
const QPixmap **freqPix;

#define  freqDPix(Sym)  freqPix[ Sym <3  ? Sym+DIR_OFF : Sym ]

void updateDrivers();

void runFilesan(char *chs);

int setCWD(const char *pth, int msg,  LVItem *it=NULL);

void closeORlist();

LVItem **deleteItems;
int it_pre, it_cnt;

IVItem **deleteIcons;
int ico_pre, ico_cnt;

int  vispos;
LVItem	*focusIt;
IVItem *focusIco;

QTimer *notifyTimer;
FILE *notifyFP;

// treeview->seekDir(const char *path, int sw, const char *dst=NULL, int typeIco=0);
void subDirs(const char *dn, LVItem *dirIt, int msg/* not thread */);

void MVCWD(char *dn, bool isComb);

void setDirNoSort();

void viewRemove(const char *dnam, FastBlock *fvp_lst, ListOpera *fvp_lo, int i, int cnt_dir, bool isdir);

void updatePathComb(char *fdirnam);

void IdSelects();

int *_Params; // consrtuct init on here order !!!

int cursorTimes, navBtn, DelTag,
	modul, // 0 is dirview; 1 place; 2 ...;
	itemDel,  iconDel,
	disktime,
	popWdgId,
	wheel_tm,  tagCount,	init_rt, 
	_viewCodec, defCode, bakCodec, ar_engIdx,
	notifyTM, colIdx, listview_sort, iconview_sort;

QWidget *focusWdg;

const char *homeUnder, *homeName,
	*Filter, *curItemTxt;
char  *dirNam,
	*oldName; // use for rename

const int u_id, g_id;
int renId, renCase0Id, renCase1Id, oldId, caseId,
	dirNoSortId, showHideId,
	fspccmpId, ccmpId, dccmpId, dcmpId,
	prgTmId, langId;

/* ____________copy______________
int copyResult, copyMode, copiedTimes;
unsigned long copySize, cpSzM;
time_t cp_tm, take;
bool stopCopyForExit;
________________________________*/

bool   brwImg, sort_ascend,
	showHide, newMsg, fspTag, thrImg,
	notifyMsg, notifying, notifyDisk/* mount disk */,
	runImg,	tmDoing, dragDel;

WId vDir;

SearchModify *search_mdf_wdg;
ORLcon *orlZone;

void freshDirItem(LVItem *any /*, bool*/);
void sortView(int n);

void modulsInit(bool init);

int PreCopyStats(int c=0);

void changButton(QAction *btn, const char *chs, int c, bool able);

void runStatus();
void creatMultPanel();
/* QRect multRect, curViewRect; */

QSplitter *one, *mainSplit;
BaseWidget *mainBW, *dirBW;
void multPanelResize(BaseWidget *bw);

void leavePlace();
TreeView *treeview;
ListContent *_filelist, *_orllist;
ImageFileView *_iconview;
QScrollView *creatIconView(QWidget *wdg, int sw=0);
QScrollView *currentView();
char *currentItemPath();
char *curSelItemPath();

LVItem *fspListItem();

FastBlock  fsels, Idsels,
pdklst, dno_dir_lst, dno_file_lst;

ListOpera dno_d_lo, dno_f_lo;

void renaming(char *pt, int vw, bool pop=false);

int deleteLV(const char *nam);
int deleteIV(const char *nam);

int delIV(IVItem *ico, int val=1);
int delLV(LVItem *it, int val=1);

Combo *pathComb;

int vFileCnt, vDirCnt, CurDirMode;

QLabel *statLab;
QFrame *lines[lineCnt];
void setFSInfo();
bool isViewOpera();
char *listFullPath(LVItem *it);
char *viewFullPath(IVItem *it);
void procSelects();

QString stocksStr;
void creatAccount(const char *pdir, int img, QString &str, FastBlock *plst, int id);
void personsMenu(ActMenu *menu, const char *dn, int img, FastBlock &lst, int (*fun)(__ORD *pdir, __ORD *dir));

__ORL *cORL;

bool isFspOpera();

bool isFsp(const char *fnam, bool show);

void creatORLList();
int ORLtm;

int idxIcon;
void **pIcon;

// isView : >0 View, 2 is recover; 0 tree; 
//return : 0 ok,  -1 false, 2 cancel
int  delFile(void *it, int isView, int id);

char *createObj(const char *pth, int sw);

void setPathComb(const char *pth);

void holdWait();

void freshView(const char *dirname, bool eXe, FastBlock *dir_lst, ListOptions *d_mode,
	FastBlock *file_lst, ListOptions *f_mode);
void createTree(const char *fdirnam, FastBlock *dir_lst, ListOptions *d_mode, int msg, LVItem *Parent);

QTextCodec *vStrCodec;

const QPixmap *idPix;
struct stat64 statbak;
int filePixmap(const char *fn);
QToolButton *treeDescendBtn, *fastTagsBtn, *placeBtn, *ORoseBtn, 
*multPanelBtn, *panelRightBtn, *toolPanelBtn,
*reFreshBtn, *listBtn, *browImageBtn, *onlyFileBtn, 
*_multPanelBtn, *_list, *_browImg, *_onlyFile,
*creatPB(QWidget *wdg, int Img, const char *tips, QObject *, const char *slot, bool togg, bool on, int key=0);

QAction *parentDirAct, *homeAct, *backDirAct, *nextDirAct,
 *cp2dirAct, *mv2dirAct, *deleteAct,
 *selectDoneAct, *selectAddAct, *selAllAct,
 *proEdit2Act, *proEditAct, *simpleImageAct, *propertiesAct, *dirSumAct,
 *copyAct, *fdupAct, *moveAct, *linkAct,
 *genArchAct, *ORLarchAct,
 *cpLogAct;
StatusPanel *bottomPanel, *topPanel;
QToolBar *topBar, *bottomBar;

ActMenu // *summaryMenu, *operaMenu, *tagMenu,  *confMenu,  *personMenu,  *codecMenu, *operaSrcMenu,
	*newMenu, *stocksMenu,  *topMenu[7];
QPopupMenu *subCode, *langMenu, *ccmprsMenu, *ORLccmprsmenu,
	*arEng, *ORLarEng;

void setFonts(const QFont & fnt);
LVItem *rootItem;
IVItem *renIco;
};

extern QPtrList <Filesan> filesors;

extern FastBlock langlst, stockslst, lifelst;

extern __ORD *FileAssoc;
extern QListView *cpListView;

extern const char Fophonix[],	slot_addtag[],
 	sig_chsel[],		slot_chsel[],
	sig_iCurCh[],	slot_iCurCh[],
	sig_lCurCh[],	slot_lCurCh[],
	slot_closall[],
	slot_newDir[],	slot_multPanel[],
	_Spc[], clickSig[],		slot_vEnter[],
	slot_open[],	slot_addSrc[],
	slot_asSrc[], slot_ren[], slot_del[],
	slot_selall[],	slot_attrib[],
	slot_list[],	slot_imgbrw[],	slot_onlyfile[],
	slot_dsum[], slot_cp2dir[], slot_mv2dir[];

extern const char **colName, **cpListCols;
extern const char *p_dtfmt;
extern char *colOptRslt, useCols[colOptCnt];

extern int sysCmdId,
	comD, inputH;

enum ListColOpt {sizeOpt, mtimeOpt, atimeOpt, usrOpt, groupOpt, attribOpt, typeOpt };
enum sureDelRlt {SureDel, NoDel, AllDel, CancelDel };

#define  is_rTag(m)  ((m&ICO_NOREAD)==0)

extern const QPixmap *selectTagPix(int Sym);

extern const char AlphChs[];

extern const char oraEng[3][8],
	_engn[arCnt][6];

extern void loadSearchModify(Filesan *fs);

extern QScrollView *creatFileList(QWidget *wdg, void *ptr, const char *cols, char *use_cols, int sw);

#define  isHideDir(pt)  strstr(pt, "/.")
#define  isDirList(pt) ( modul!=NO_MULT_PANEL && isHideDir(pt)==NULL)

#define		ini_slot_cnt   5
#define		_iconview_slot_cnt   7

extern const char *_filelistSig[ ini_slot_cnt ], *_filelist_slots[ ini_slot_cnt ];

#endif
