/*
    Write by LinJiangHua(xempo) 8-2011
    Copyright LinJiangHua 8-2011
*/

#include <qcursor.h>
#include "filesan.h"
#include "treeview.h"
#include "xfun.h"
#include "../rtdata/en/target/filesor.h"

int icoTimId;

bool doDrop;

#define	restoreOn	128

const char vIcon[]="vIco";

IVItem::IVItem(QIconView *v, IVItem *after, const char *txt, bool isdir, bool can_drop) :
	QIconViewItem(v, after, tranText(strCodec, txt)),
	fnam(strdup(txt)), _dir(isdir), _canDrop(isdir&&can_drop)
{
}

IVItem::IVItem(QIconView *v, IVItem *after, const char *txt, const QPixmap &icon, QTextCodec *codec, bool isdir, bool can_drop) :
	QIconViewItem(v, after, tranText(codec, txt), icon),
	fnam(strdup(txt)), _dir(isdir), _canDrop(isdir&&can_drop)
{
}

IVItem::~IVItem()
{
free(fnam);
}

void IVItem::_setName(const char *nam)
{
free(fnam);
fnam=strdup(nam);
}

ImageFileView::ImageFileView(QWidget *par) : QIconView(par, vIcon),
	stayItem(NULL), tms(0), filesor((Filesan *)par->topLevelWidget()/*->parentWidget()->parentWidget())*/),
	testResult(0), startDrag(NULL),
	dragOpen(*pixmapLoad(dragOpenImg))
{
setResizeMode(QIconView::Adjust);
setGridX(80);
setSorting(false);
setWordWrapIconText( true );
setSelectionMode(QIconView::Extended);
// viewport()->setAcceptDrops(true);
/*setAcceptDrops(true);*/
//connect(this, SIGNAL(dropped(QDropEvent *, const QValueList<QIconDragItem> &)),
//	filesor, SLOT(dropExec()) ); move to Filesan::creatIconView
}

IVItem *ImageFileView::Index(int idx)
{
int i;
IVItem *ico=(IVItem *)firstItem();
for(i=0; i<idx; i++)ico=(IVItem *)ico->nextItem();
return ico;
}

bool canBeDrop(QStrList &lst, const char *dst, bool isTree)
{
  const char *fn, *idx;
  int i, L, d;
  for( i=0; i<lst.count(); i++){
	fn=getDropFN(lst.at(i), &d);
	L=strlen(fn);
	idx=strrchr(fn, '/');
	if( !(strstr(dst, fn)==dst && (dst[L]=='/'||dst[L]==0) ||
	(isTree && strstr(fn,dst)==fn&&idx==fn+strlen(dst)) ) )return true;
	}
  return false;
}

void FastBlock::cvtQStrList(const char *cap, QStrList *lst)
{
  int i;
  if(list==NULL)memDiv(NULL);
  for(i=0; i<cnt; i++)
	lst->append(cap ? catstr(cap,list[i], 0) : list[i]);
}

inline void ImageFileView::setSelStat(IVItem *ico)
{
    tms=0;
    char *fnam=filesor->itemFullPath( ico );
    int H=strcmp(fnam, home);
    testResult=testFile(ico, fnam);
    free(fnam);
    switch(testResult){
// case lost_Link : break;
    case 0 :
    case symLink :
	if(startDrag!=ico){
		stayItem=ico;
		oldpix=*ico->pixmap();
		ico->setPixmap(doDrop ? (H==0 ? *pixmapLoad( _homeOpenImg) : dragOpen) :  *pixmapLoad(critImg));
		testResult=restoreOn;
	}
    }
    if(doDrop==false)filesor->stBar()->showMsg(DropSub, 20, true, 0xb02420);
}

/*void ImageFileView::contentsDragMoveEvent( QDragMoveEvent *e )
{
IVItem *it = (IVItem *)findItem( viewport()->mapFromGlobal( QCursor::pos() ) );
if( dropMeet != it || lstbuf.count()==0 ){
	dropMeet=it;
	lstbuf.clear();
	QUrlDrag::decode(e, lstbuf); 
}
if( canBeDrop(lstbuf, filesor->getDirNam(), false) || e->action()==QDropEvent::Copy )e->acceptAction(true);
else {	e->acceptAction(false);	e->ignore();	}
}*/

bool ImageFileView::event( QEvent *e )
{
switch(e->type()){
case QEvent::Timer : if(++tms>6){
	IVItem *ico = (IVItem *)findItem( viewport()->mapFromGlobal( QCursor::pos() ) );
	tms=0;
	if( ico !=stayItem )setSelStat(ico);
	}
	return true;
case QEvent::FocusIn : filesor->objsUpdate();
}
return QIconView::event(e);
}

int ImageFileView::testFile(IVItem * ico, char *pt)
{
  IVItem *curIco=(IVItem *)currentItem();
  struct stat64 sndstat;
  int rt;
  switch(rt=isExist(pt, &sndstat)){
//  case none_File :	// ico=(IVItem *)ico->nextItem(); if(ico)return 1;
//		return -1;
  case lost_Link :  if(curIco==ico)showLink(filesor->stBar(), lnkNone, pt, 0xe03b0a);
	break;
  case symLink : if(curIco==ico)showLink(filesor->stBar(), linkAs, pt, 0x208020);
	}
  return rt;
}

void ImageFileView::selectedCollect(FastBlock *fsels)
{
IVItem *curIco=(IVItem *)currentItem();
if(curIco){
  char *pt;
  int idx;
  IVItem   *ico=(IVItem *)firstItem();
  fsels->setIndex(0);
  do if( ico->isSelected() && ico->fnam ){
	pt=filesor->itemFullPath( ico );
	switch(testFile(ico, pt)){
	case lost_Link :
	case 0 :
	case symLink : idx=fsels->add( pt );
		if(curIco==ico)fsels->setIndex(idx);
	}
	free(pt);
	}
  while( /*ico &&*/ (ico=(IVItem *)ico->nextItem())!=NULL );
  fsels->memDiv(NULL);
}
}

IVItem *ImageFileView::curSelIco()
{
IVItem *curIco=(IVItem *)currentItem(), *selIco=NULL;
if(curIco){
  IVItem  *ico=(IVItem *)firstItem();
  do if( ico->isSelected()  ){
	if(ico==curIco)return ico;
	selIco=ico;
	}
  while( /*ico &&*/ (ico=(IVItem *)ico->nextItem())!=NULL );
}
return selIco ? selIco : curIco;
}

QDragObject *ImageFileView::dragObject()
{
 IVItem *ico=(IVItem *)currentItem();
 if(ico){
  QStrList lst;
  
  filesor->getFSels()->cvtQStrList(tfile, &lst);
  QUriDrag *ud = new QUriDrag( lst, viewport());
  ud->setPixmap(*ico->pixmap());
  startDrag=ico;
  ud->drag();
  endTimer();
  startDrag=NULL;
 }
 return NULL;
}

void ImageFileView::restoreIcon()
{
tms=0;
if(testResult==restoreOn)stayItem->setPixmap(oldpix);
stayItem=NULL;
testResult=0;
}

void ImageFileView::endTimer()
{
if(icoTimId){
	killTimer(icoTimId);
	icoTimId=0;
	}
}

void IVItem::dragLeft()
{
((ImageFileView *)iconView())->restoreIcon();
((ImageFileView *)iconView())->endTimer();
}

bool IVItem::acceptDrop( const QMimeSource *e ) const
{
if(_canDrop){
	QStrList lst;
	QUrlDrag::decode( e, lst );
	char *fn=((ImageFileView *)iconView())->_filesor()->itemFullPath( this );
	doDrop=canBeDrop(lst, fn, false);
	free(fn);
	if(icoTimId==0){
		((ImageFileView *)iconView())->setTms(0);
		icoTimId=iconView()->startTimer(80);
	}
	return doDrop;
	}
doDrop=false;
return false;
}

void IVItem::dropped( QDropEvent *e, const QValueList<QIconDragItem> & )
{
ImageFileView *_iconview=(ImageFileView *)iconView();
IVItem *icon=_iconview->getStayItem();
_iconview->endTimer();
if(icon){
  if(doDrop){
	Filesan *fs=_iconview->_filesor();
	char *dst=fs->itemFullPath( icon );
	procDrop(fs, fs, e, dst);
	free(dst);
	}
  _iconview->restoreIcon();
}
else e->ignore();
}

