/*
	林江华(xempo)编写，2010-2，Copyright LinJiangHua
	Free under LGPL
*/

#ifndef    TREE_VIEW
#define    TREE_VIEW

#include "listcontent.h"
#include "ordir.h"
#include "../rtdata/en/target/filesor.h"

enum MultPanel_Mode { _OSROOT, _PLACE, _FASTTAGS, _OPENROSE, NO_MULT_PANEL };

class QTimer;

class TreeView : public ListContent
{
 moc_Object
public :
TreeView(QWidget *wdg, int id, Filesan *fs);
// ~TreeView();

LVItem *seekDir(const char *path, int sw, const char *dst=NULL);

int setItemCurDir(LVItem *it);

LVItem *newDirItem(const char *nam, const QPixmap *pix, int est ); /* est 是否exist item, 0 create, 1 exist */

void treeRemove(LVItem *);
void treeDel(LVItem *);

void treeSort(int Msg);
void sortTagsItem(){ sortItem((LVItem *)firstChild(), pms_sorttag, tagsRoot); }

void updateParts();
void selPart(LVItem *it, char *dat=NULL, int i=0);
char *tagFullPath(LVItem *);
void createTags();
void creatTagItem(int i, int sort);
void createOpenRose(bool init);

__ORD *testORD(LVItem *it);

__ORD *getORD() const
{ return ORD; }

void setFsp(__ORL *fsp){ orlLib=fsp; }

void setORD(__ORD *dir){ ORD=dir; }

void setRecent(__ORL *lib){ recentORL=lib; }

__ORD *itemORD(LVItem *it);
__ORL *itemORLRoot(LVItem *it);

void freshItem(LVItem *it, __ORD *dir, int sub);

__ORD * selORD(LVItem *it, __ORD *pdir, int msg);

LVItem *seekORD(__ORL *fsp, const char *path, int msg);

// LVItem *deelORD(__ORD *dir, int msg);

void chORD(LVItem *it);

inline bool testLost(); // listcontent.cpp

void selectORD()
{
setSelected(fspSel ? fspSel : (LVItem *)currentItem(), true);
}

void treeLostDel(LVItem *it);

private :
LVItem *selDir, *fspSel, 
	*fsRootItem, *sendItem;
void takeFS();
void exeMount(const char *pt);

int *_Params;
bool lostTag, subDirCreat, seekDirMsg,
 skpslot; /* select-slot */

QTimer *dirLostTimer;

__ORD *ORD;
__ORL *orlLib, *recentORL;

int setTreeDir(LVItem *dirIt, int tag); //return: 0正确, 否则 enum FILE_TEST { }
void sortSub();

LVItem *sortItem(LVItem *it, int sort, const char *nam);

};

extern void doMount(FastBlock *lst);
extern void getMount(FastBlock *lst, FastBlock &tmp);
extern int listViewIndex(QListView *lvw, LVItem *it);
extern bool isMount(const char *dnam);

extern int _selORLNum(__ORD *pdir, BYTE *unit); // orltree.cpp

extern void removeLeft(LVItem *it);

#define	testRemoveDir(fnam)		seekDir(fnam, TEST_REMOVE_DIR)
#define	removeDir(fnam)		seekDir(fnam, REMOVE_DIR)

extern const char  slot_doRen[],	sig_doRen[],
	sig_enter[],
	sig_expand[], slot_expand[];

#endif
