/*
	Write by xempo(LinJiangHua)
	Free under LGPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include "fmtinp.c"
#include "setargv.c"
#include "memstr.c"
#include "filter.c"
#include "catstr.c"

__time_t objtm;

static int testdir(const char *dn, const char *flt)
{
  int rt=1;
  DIR *dir=opendir(dn);
  if(dir==NULL){
	perror(dn);
	return -1;
	}
  struct stat st;
  struct dirent *dent;
  char *fn, *pt;
  while( rt>0 && (dent=readdir(dir)) ){
	fn=dent->d_name;
	if(strcmp(fn, ".")==0 || strcmp(fn, "..")==0 )continue;
	pt=catstr(dn, fn, '/');
	stat(pt, &st);
	if(S_ISDIR(st.st_mode))rt=testdir(pt, flt);
	else if(namefilters(fn,flt, 1) && st.st_mtime>objtm)rt=0; /*  flt="*.htm,*.rls,*.pts"  */
	free(pt);
	}
  closedir(dir);
return rt;
}

int main(int argc, char **argv)
{
int rt=1;
const char usg[]="Usage : dirtest [objfile] [dir] [filters]\n\tMust 3 parameter",
	*msg="\"%s\" will be rebuild !\n";
if(argc>3){
  struct stat st;
  if(stat(argv[1], &st)){
	msg="Build \"%s\" ...\n";
	rt=0;
	}
  else {
	objtm=st.st_mtime;
	rt=testdir(argv[2], argv[3]);
	}
  if(rt==0)printf(msg, argv[1]);
  }
else puts(usg);
return rt;
}
