/*
	Write & edit by Linjianghua 2005-06,2008-2010
	Free under LGPL
*/

#include "normal.h"
#include "ordir.h"
#include "orlio.h"
#include "rebuild.h"
#include "conspace.h"
#include "stdfun.h"
#include "infor.h"
#include "read.h"
#include "dlist.h"
#include "script.h"
#include "shellcom.h"
#include "jxswitch.c"

const char curSpace[]="Create workspace : %d", RLS[]=".rls",
	*pExeNam[4]={ extORL, ".fsp", RLS, NULL };

extern char *OutBuf;

void (*extDest)();

int runinginfo;

__ORL *workspace[SPACELIMIT];

const char *ORLver(__ORL *lib)
{
static  char verbuf[16];
sprintf(verbuf, "  Ver%d.%d.%d", lib->ver1, lib->ver2, lib->ver3);
return verbuf;
}

void ORLinfo(__ORL *lib, char *buf)
{
   (void)sprintf(buf, libfmt, lib->fname ? rstrrchr((char *)lib->fname, ROOT_CH,ROOT_CH) : ORLver(lib),
	lib->tolNumb,lib->tolDir,lib->useSize,lib->fsz);
}

void readCORD(__ORL *lib)
{
   if(lib->DefaultDir>40){
	lib->CurDir=ORDread(lib,ORDalloc(),NULL,lib->DefaultDir, False);/* default dir */
	if(pGetPdExt)pGetPdExt(lib->CurDir);
   }
}

BOOL ORputas(__ORL *lib, int i)
{
if(lib->openTimes)return True;
if(i<0)for(i=0; i<SPACELIMIT&&workspace[i];i++);
else if(workspace[i]){ // special space-numb
	ORtips(55, 1);
	return False;
	}

if(i<SPACELIMIT){
  workspace[i]=lib;
  lib->openIdx=i;
  return True;
  }
else defaultHB(46);
return False;
}

#define  IsAbsPath(fnam)	( *fnam=='\\' || *fnam=='/' )

int usedORL(const char *fnam, const char *inpPath)
{/* inpPath use in script  genery*/
int i;
char *ptr=isExec(fnam, pExeNam, inpPath);
if(ptr){
  char *pth;
  pth=fullname(ptr);  free(ptr);
  for(i=0; i<SPACELIMIT && (workspace[i]==NULL ||strcmp(pth,workspace[i]->fname)); i++);
  free(pth);
  return i<SPACELIMIT? i:-1;
}
return -1;
}

__ORL *ORLuse(const char *fnam, OpenSpace msg)
{
  int nmb, i=usedORL(fnam, NULL);
  if(i>-1){
	workspace[i]->openTimes++;
	return  workspace[i];
	}
  __ORL *lib=ORLopen(fnam, msg);
  if(idxdscpt>0x7ffd){
/*      nmb=idxdscpt; */
      if( msg & OpenAlway )lib->openMode=OpenAlway;
      if(msg&HasFullPath)lib->fname=fnam;
      else {
	const char *fn=lib->fname;
	if( ! IsAbsPath(fn) ){
		lib->fname=fullname(fn);/* curprgnam perhan is filename */
		free((void *)fn);
	}
       }
      if(msg&OpenLastDir)readCORD(lib);
      if(msg&RScript){/* read script */
	char *pt=sysIdRead(lib,SCRIPT_ID);
	if(pt){
		msgShow(pt);
		free(pt);
		}
	else if(idxdscpt==NoNumb_4)idxdscpt=0x7fff;
	         else goto _jmp_;
	}
  }
  else {
      char *pt=NULL;
      if(msg&CompactMsg){
	nmb=idxdscpt;
	if(nmb==1){
	   __ORD *dir=ORDopen((__ORD *)*workspace, "Compact", DIR_READ);
	   if(dir){
		BYTE *stat;
		MAU mau[2];
		char verbuf[48];
		int L;
		i=0;
		FILE *fp=fopen(fnam, "rb");
		L=fread(verbuf, 1, 47, fp);
		fclose(fp);
		while( (stat=NumRead(dir, i, mau, 2)) ){
			free(stat);
			pt=memstr(verbuf, L, mau[0].buf, mau[0].len,1|2);
			if(pt==verbuf)msgShow(mau[1].buf);
			freeMAU(mau, -2);
			if(pt==verbuf)break;
			i++;
		}
		ORDclose(dir, 0);
	   }
	}
	idxdscpt=nmb; /* reset old-value, NumbScan change idxdscpt, for script */
      }
      if(pt==NULL)_jmp_: if(msg&ORLerror)reportBug();
  }
return lib;
}

__ORL *ORLspac(const char *pth, OpenSpace msg, int space_num)
{
__ORL *lib1;
const char *pt=NULL;
if( (lib1=ORLuse(pth, msg/* norm=1+2+4+8 */)) ){
    bakdscpt=0x7fff;
    if(lib1->openTimes){
	if(lib1->openIdx>0)pt="\npop %d as current space";
	else ORtips(50/* self-rtl */,True);
	}
    else  {
	if((msg&OpenAlway)==0)pt=curSpace;
	if(space_num>-2&&ORputas(lib1, space_num)==False){ ORLclose(lib1,NULL); return NULL; }	
	}

    if( (msg&ORLopeninfo)&&(diguei==0||runinginfo) ){
	ORLinfo(lib1, OutBuf);
	msgShow(OutBuf);	
	ORDinfo(lib1->CurDir, OutBuf);
	msgShow(OutBuf);
	}
}

if(pt&&space_num>-2){
	if(getMsg){
		lock=-1;
//		if(i>0)pt++;
	}
	(void)sprintf(OutBuf, pt, lib1->openIdx);
	msgShow(OutBuf);
	lock=0;
}
return lib1;
}

__ORL *ORLcreat(const char *fnam, const un_Int *pms)
{
FILE *pff;
if((pff=fopen64(fnam,"wb+"))!=NULL){
    char buff[32];
    __ORL *lib=ORLalloc();
    idxdscpt=0x7fff;
    ORtime(0, lib->datebuf);
    lib->fpt=pff;
    lib->name[0]='/';
    setPdPara((__ORD *)lib,pms);
    if(pms==NULL/*fastbuf==False*/ ||pms[pd_param_cnt+1]==False)setbuf(pff, NULL); /* real time protect data */
    lib->parent_adr=1;
    lib->SysNum_FCUs_Block=SYS_ID_BLOCK;
    lib->CmprSiz=16; /* k */
    lib->cmprPer=30;
    memcpy(buff, FileFmt, blockSize);
    buff[fmt_CtrlSize]=CTRLSIZE-1; /* prognamLen+4 */
/*    lib->ver1=buff[prognamLen+1];
    lib->ver2=buff[prognamLen+2];
    lib->ver3=buff[prognamLen+3];
    lib->CtrlSiz=CTRLSIZE-1;*/
    memcpy(&lib->ver1, buff+prognamLen+1, 4);
    fwrite(buff,blockSize,1,pff);
    lib->fsz=CTRLSIZE-1+blockSize;
    lib->useSize=CTRLSIZE-1+blockSize;
    lib->fname=fullname(fnam);
    setZero((__ORD *)lib, pms ? pms[pd_param_cnt] : 12);
    return lib;
}
else idxdscpt=UnCreat_11;
return NULL;
}

void ORLreleas(__ORL *lib, void (*fun)(void *p))
{
if(lib){
    if(lib->openTimes>0){
	lib->openTimes--;
	return;
	}
    if((lib->openMode&OpenAlway)==0){
	workspace[lib->openIdx]=NULL;
	if(fun)fun(lib);
	ORLclose(lib,ORLrebuild);
    }
}
}
