/*
	Write & edit by Linjianghua(Xempo) 2004-2006,2008-2010,2011-2012, 2014-2016
	Free unde LGPL
*/

#include "normal.h"
#include "ortime.h"
#include "dirext.h"
#include "dirloop.h"
#include "orlio.h"
#include "fculoop.h"
#include "chMT.h"
#include "_fcu.h"
#include "find.h"
#include "copys.h"
#include "rebuild.h"
#include "dlist.h"
#include "export.h"
#include "script.h"
#include "conspace.h"
#include "infor.h"
#include "numbtype.h"
#include "read.h"
#include "write.h"
#include "shellcom.h"
#include "jxswitch.h"
#include "stdfun.h"
#include "calc.def"
#include <sys/stat.h>
#include <dirent.h>

#include "version.c"
TxtDat *TDS;

const char newSepa[]="=";

static const char failexe[]="Fail to exec %s";

char **_argv;

void setCfgVal(char *pms)
{
char **plst;
int cmd, n=800, j, msg=0;
static const char params[]="err-msg-on,err-param-reco,oldcompa";
plst=setargv(pms, ";,\r\n", &n);
for(j=0; j<n; j++){
	cmd=GetComm(plst[j],params,NULL,NULL);
	if(cmd>-1)cfgval[cmd]=True;
	else {
		msg=1;
		if(getMsg){
			char buf[128];
			(void)sprintf(buf, "Wrong cfg-params : <font color=#b01810>%s</font>",plst[j]);
			getMsg(buf);
		}
		else printf("Wrong cfg-param : \033[31m%s\033[0m\n",plst[j]);
		}
	}
free(plst);
if(msg){
	if(getMsg){
		char buf[240];
		(void)sprintf(buf, "List cfg-params : <font color=#0506c0>%s</font>", params);
		getMsg(buf);
	}
	else printf("List cfg-params : \033[34m%s\033[0m\n", params);
}
}

BOOL setSpace(__ORL *send, __ORL *curlib)
{
  if(send&&(send->openMode&OpenAlway)==0){
	int n=send->openIdx;
	ORLreleas(send, extDest);
	return ORputas(curlib, n);
  }
  else return ORputas(curlib, -1);
}

__ORL *openORL(__ORL *send, int n, char **pm, int msg, int ncmd)
{
__ORL *lib;
int Root=0,  i=0, N;
static const char  *_OpenMode="--root", 
	*_OpenMode2="--as";
 ProcOpt opt1={	1, NULL, &_OpenMode,	&Root,	0, NULL, 0	  },
	opt2={	1, NULL, &_OpenMode2,	&i,	0, NULL, 0	  };
 arglists *alst=procParas(n, pm, &opt1, &opt2);
//  if(alst&& no invObj
 if(alst->argc){
	if(i){
		N=atoi( alst->subarg->argv[0] );
		if(N>=SPACELIMIT){
			ORtips(56, 1);
			goto _jmp_;
		}
	}
	else N=ncmd==ORL_open ? -2 : -1;

	for(i=0; i<alst->argc; i++)
	     if( (lib=ORLspac(alst->argv[i], Root ? msg : msg|OpenLastDir, N )) ){
		if( N<-1 )setSpace(send, lib);
		send=lib;
		}
	_jmp_: argsFree(alst);
 }
 else { ORtips(I_None_58, 1); showUsage(ncmd); }
 return send;
}

static __ORL *exeScript(__ORL *send, int n, char **pm, int msg, const char *inpPath)
{/* inpPath use in script  genery*/
	static const char *_msg[2]={ "--nowarn", "--append" };
	int extval[2], i;
	char *pt;
	memset(extval, 0, sizeof(int)*2);
	ProcOpt opt={ 2,	NULL, _msg,	extval,	0,  NULL, 0		};
	arglists *alst=procParas(n, pm, &opt, NULL);
	if(alst->argc){
	  for(i=0; i<alst->argc; i++){
	    pt=isExec(alst->argv[i], pExeNam+2, inpPath);
	    if(pt){
		send=ORLscript(send, pt, extval[1] ? 2|msg : msg, inpPath); 
		free(pt);
		}
	    else if(extval[0]==0){ // no --nowarn
		msgShow(alst->argv[i]);
		ORtips(0,1);
		}
	    }
	}
	else { ORtips(I_None_58, 1); showUsage(ORL_exe); }
	argsFree(alst);
	return send;
}

inline __ORL *exeFile(__ORL *send, int argc, char **argv, const char *inpPath)
{/* inpPath use in script  genery*/
  char *pt, *pm=isExec(*argv, pExeNam, inpPath);
  if(pm){
    __ORL *lib;
    *argv=pm;
    lib=openORL(send, argc, argv, (3|16|32), ORL_open);
    if(idxdscpt<2/* 0,1 can't open, unknow */ &&
	(pt=strstr(pm, pExeNam[2]))!=NULL&&strcmp(pt,pExeNam[2])==0){
	  idxdscpt=0x7fff;
	  lib=exeScript(send, argc, argv, 1, inpPath);
	}
    free(pm);
    if(lib)return lib;
    else if(idxdscpt<0x7ffd)reportBug();
  }
  else CommNumb=-10;
  return send;
}

static void showWS(__ORL *lib)
{
if(lib){
	const char *ver=ORLver(lib);
	if(getMsg){
		char buf[400];
		(void)sprintf(buf, "<font color=#080890>WorkSpace</font>: %d, <font color=#08800a>%s</font>%s", lib->openIdx,lib->fname,ver);
		getMsg(buf);
		}
	else printf("\033[31m  WorkSpace: \033[33m%d,  \033[34m%s\033[0m%s\n",lib->openIdx,lib->fname, ver);
	}
}

static int tryHelp(const char *cmd)
{
int i, j;
char *buf, ch;
const char *pt=comchs;
i=0;	j=strlen(cmd);
buf=(char *)malloc(2048);
_fndcmd_: 
if( (pt=memstr(pt, 0, cmd, j,1)) ){
	if(pt!=comchs && pt[-1]!=',' && pt[-1]!='\n' ){
		pt++;
		goto _fndcmd_;
	}
	do ch=*pt++;
	while( (buf[i++]=ch)!=0 && ch!=',' && ch!='\n' );
	goto _fndcmd_;
}
while( i>0&& ((ch=buf[--i])==',' || ch=='\n' ) );
if(i){
   buf[  i+1 ]=0;
   if(getMsg){
	sprintf(buf+i+2, "<font color=#b02320>%s</font><br/><font color=#10109f>  %s</font>", buf, rt_msg[3]);
	getMsg(buf+i+2);
	}
   else printf("\033[31m%s\n\033[34m  %s\033[0m\n", buf, rt_msg[3]);
}
free(buf);
return i;
}

static int cmprInv[3]={0, 1, 2 };

static const char *fltchs="-F" , *_fltchs="--filter";
__ORL *comRun(__ORL *send,char *inpbuf, int env, const char *inpPath)
{
/* env, 0bit : append;  1bit : mkar, no info */
  char *pt, **lst, **pm;
  const char  *fn, *extpara;
  static const char ON[]="on", OFF[]="off";
  __ORL *curlib=NULL;
  __ORD *dir;
  int sel=0, i, j, n=8000, N, ncmd, numb;
  BOOL selret;
  MAU mau;
  ncmd=GetComm(inpbuf,comchs,kval,&extpara); /* inpbuf[0]==0 , ncmd=EmptyEnter */
  switch(ncmd){
  case ORL_runinginfo : runinginfo=True;
	return send;
  case ORL_add /* add dir1/data */:
  case ORL_write :
  case ORL_insert /* insert.v==write */ : n=3; /* limit */
	break;
  case ORL_append :
  case ORL_calc  :
  case ORL_orlconf :
  case ORL_setcfgval /* set cfgval */ :
  case ORL_orlinit :
  case ORL_setdscpt : n=2; break;
  }
  lst=setargv(inpbuf, separaChs, &n);
  if(*inpbuf==0)return send;
  if(ncmd==NotCommand)goto _exeScript_;
  if( n==2 && (j=GetComm(lst[1],"-h,--help",NULL,NULL))!=NotCommand)goto _cmdUsage_;
  if( ncmd>3411 )goto _let;
  selret=getSpace(extpara, &sel, &j);

  if(send==NULL){
	if(selret )goto _selsp_;
	if( ncmd==ORL_rebuild && n>1 )goto _let;
	if( ncmd<2200 ){
		ORtips(NoBuff_2,1);
		goto _exit_;
	}
  }
  if( ( n<2 && ( (ncmd>2187&&ncmd<2241) || (ncmd>-200 && ncmd<2170) ) )
	|| (n<3&&ncmd<-479) ||
	(n<4 && ncmd==ORL_osdirloop) ){
_cmdUsage_: showUsage(ncmd);
	goto _exit_;
    }

  if(ncmd==NotCommand){ /* no input EmptyEnter */
_exeScript_: send=exeFile(send, n, lst, inpPath);
	if(CommNumb==-10){
		char buf[260], buf2[200];
		pt=*lst;
		(void)sprintf(buf, rt_msg[2], pt);
		msgShow(buf);
		if( strlen(pt)>2 ){
		    pt[3]=0;
		    if(tryHelp(pt)==0){
			if(getMsg){
				(void)sprintf(buf2, "<font color=#000090>help %c%c</font>", *pt, pt[1]);
				(void)sprintf(buf, rt_msg[4], buf2);
				getMsg(buf);
				}
			else {
				(void)sprintf(buf, "\033[7mhelp %c%c\033[0m" , *pt, pt[1]);
				printf(rt_msg[4], buf);
			}
		    }
		}
		scriptTips(0);
		}
	goto _exit_; 
    }
  else {
	if( selret ){
_selsp_:	    if((sel=selSpace(sel))<0)goto _exit_;
	    curlib=workspace[sel];
	}
	else  _let: curlib=send;
   }
/* ORL_quit(4096) abort prg result, like script error and not make follow, use it.  ORL_exit(11520) norml-exit */
  CommNumb=ncmd;
  n--;  pm=lst+1;
  switch(ncmd){
  case ORL_calc : {
	double rt=calc(*pm);
	if(n_CalcErr)msgShow(calcErr());
	else {
		(void)sprintf(OutBuf, "%lf", rt);
		goto _msg_show_;
		}
	}
	break;
  case ORL_echo :
	if(n){
		if(strcmp(*pm,ON)==0)CommNumb=echo_on;
		else if(strcmp(*pm,OFF)==0)CommNumb=echo_off;
	}
	break;
  case ORL_close : ORLreleas(curlib, extDest);
//	curlib=NULL;
	if(curlib==send)send=NULL;
	break;
  case ORL_msgno : pt=GetHB( i=atoi(*pm) );
	if(getMsg){
		(void)sprintf(OutBuf,"The number <font color=#000099>%d</font> means <font color=#881212>%s</font>", i, pt);
		free(pt);
		goto _msg_show_;
		}
	printf("The number \033[34m%d\033[0m means \033[31m %s\033[0m\n", i, pt);
	free(pt);
	break;
  case ORL_impcreat : /* import creat lib in script, if have working lib, import for it,
	otherwise creat lib for script-running */
	 if(send)break;
  case ORL_newspace :
  case ORL_creat : {
#define  mu1  3
 int dir1Val[mu1];
 static const char *dir1chs[mu1]={ "-z", "-t", "-f" },
  *_dir1chs[mu1]={"--zero", "--type", "--force" };
 static const int fmk[mu1]={1, 2, DECT_OVER /* over file no ask when creat rtl-file */};
#define  mu2  6
 int dir2Val[mu2];
 static const char *dir2chs[mu2]={ "-m", "-n", "-d", "-u", "-a", "-s" },
	*_dir2chs[mu2]={ "--mode", "--numpre", "--dirpre", "--unit", "--as", "--size-of-zcache"};

 ProcOpt opt1={	mu1,	dir1chs, _dir1chs,	dir1Val,	0, NULL, 0	},
	opt2={	mu2,	dir2chs, _dir2chs,	dir2Val,	0, NULL, 0	};
      un_Int param[pd_param_cnt+2];
      param[pd_param_cnt]=12; /* default size-zcache */
      param[pd_param_cnt+1]=False;
      arglists *alst=fixPdPara(n, pm, &opt1, &opt2, fmk, param);
      if(alst){
        for(i=0; i<alst->argc; i++){
          sel=usedORL(alst->argv[i], inpPath);
          switch(sel){
          case -1 : /* no using */
	if((*param&DECT_OVER)==0 && access(alst->argv[i], 6)==0){
#ifdef  _Single
		printf("%s have exist, use -f(--force) to over.\n", alst->argv[i]);
#else
		 if(ORtips(36, 2)!='y')
#endif
			goto _out_;

		}
	break;
          case 0 :  ORtips(50, 1); CommNumb=End_Script_Run;
		goto _out_;
          default :	
		if(ORtips(35, 2)!='y')goto _out_;
		if(send&&send->openIdx==sel)send=NULL; /* the creat file exist & have open */
		ORLreleas(workspace[sel], extDest);
	}
          curlib=ORLcreat(alst->argv[i], param);
          if(curlib){ /* set 0bit freewrite-Mark, can proc 5-spe-numb */
	if((env&2)==0){
	   j=opt2.rtval[4] ? atoi(alst->subarg->argv[4]) : -1;
	   if(j>=SPACELIMIT){
		ORtips(56, 1);
		goto _skp2_;
	    }
	    ORLinfo(curlib, OutBuf);
	    msgShow(OutBuf);
	    if(j>-1||ncmd==ORL_newspace){
		if(ORputas(curlib, j )){
			(void)sprintf(OutBuf, curSpace, curlib->openIdx);
			msgShow(OutBuf);
		}
		else {
		  _skp2_:	ORLclose(curlib,NULL); break;
		}
	     }
	    else setSpace(send,curlib); // ==False)goto _skp2_;
	}
	send=curlib;
	}
      else if(idxdscpt<0x7ffd)reportBug();
      }
      _out_: argsFree(alst);
      }
#undef  mu1
#undef  mu2
     }
     break;
  case ORL_selspace :
	if(n>0){
	    if(isNumb(*pm)==False){
		ORtips(WrongOpera_22, 1);
		showUsage(ORL_selspace);
		break;
		}
	    i=atoi(*pm);
	    if(i<SPACELIMIT&&workspace[i]){
		send=workspace[i];
		curlib=send;
		if(i==0)ORtips(50, 1);
		}
	    else { ORtips(52, 1);	break; }
	}
	goto _ws_info_;
  case ORL_pwd : getcwd(OutBuf,1023);
	goto _msg_show_;
  case ORL_help : 
	if(n>0)tryHelp(pm[0]);
	else  msgShow(comchs);
	break;
  case ORL_ardir : {
#define  mu1  5
#define  mu2  1
	int Val1[mu1], Val2=0;
	static const char *cmprDir[mu1]={ "-B", "-G", "-L","-R", "-O" }, *_cmprDir[mu1]={ "--bzip2", "--gzip", "--lzma", "--replace", "--only" };
	memset(Val1, 0, sizeof(int)*mu1);
	ProcOpt opt1={	mu1,	cmprDir,  _cmprDir,	Val1,	3, cmprInv, 0	},
		opt2={	mu2,	&fltchs, &_fltchs,	&Val2,	0, NULL, 0	};
	arglists *alst=procParas(n, pm, &opt1, &opt2);
	if(alst==NULL)break; // inv Obj
	if(alst->argc){
	    dir=ORDopen(curlib->CurDir, alst->argv[0], DIR_READ);
	    if(idxdscpt<0x7ffd){ reportBug(); goto _free_; }
	    for(i=0; i<3; i++)if(Val1[i])break;
	    ardir(dir, alst->argv[1], (alst->subarg&&alst->subarg->argc>0) ? alst->subarg->argv[0] : NULL,
		i>2 ? ORL_arfile : i+1+ORL_arfile, (Val1[3] ? 1: 0)| (Val1[4] ? 2:0)  );
	}
	else { ORtips(I_None_58, 1); showUsage(ORL_ardir); }
_free_:	argsFree(alst);
#undef  mu1
#undef  mu2
	}
	break;
  case ORL_mkar : {
	int Val1[4], Val2=0;
	static const char *cmprChs[4]={ "-B", "-G", "-L","-f" }, *_cmprChs[4]={ "--bzip2", "--gzip", "--lzma", "--force" };
	memset(Val1, 0, sizeof(int)*4);
	ProcOpt opt1={ 4, cmprChs, _cmprChs, Val1, 3,	cmprInv, 0	},
		opt2={ 1, &fltchs, &_fltchs,	&Val2,	0, NULL, 0	};
	arglists *alst=procParas(n, pm, &opt1, &opt2);
	if(alst){
	  if(alst->argc>1){
	  struct stat64 fst;
	  char buf[200];
	  const char *cmpr;
	  strcpy(buf, "creat -u=2 ");
	  if(Val1[3])strcat(buf, "-f");
	  pt=catstr(buf, alst->argv[0] , 32);
	  curlib=comRun(curlib, pt,  env|2, inpPath);
	  free(pt);
	  if(send==curlib)break;
	  numb=0;
	  for(j=0; j<3&&Val1[j]==0; j++);
	  if(j>2)cmpr=SPC;
	  else cmpr=cmprChs[j];
	  for(i=1; i<alst->argc; i++)
	      if(stat64(alst->argv[i], &fst)==0){
		if(S_ISDIR(fst.st_mode)){
			BOOL flt=alst->subarg&&alst->subarg->argc;
			(void)sprintf(buf, "ardir / %s %s %s", cmpr, flt ? fltchs : SPC, flt ? alst->subarg->argv[0] : SPC); // wait ...  bzip2, gzip
			}
		else (void)sprintf(buf, "arfile %s %d", cmpr, numb++);
		pt=catstr(buf, alst->argv[i], 32);
		(void)comRun(curlib, pt,  env, inpPath);
		free(pt);
	      }
	  ORLclose(curlib, NULL);
	  }
	  else { ORtips(alst->argc>0 ? 57 : I_None_58, 1); showUsage(ORL_mkar); }
	}
	}
	break;
  case ORL_divpara :
	if(n>0){
		if(paraSepa!=newSepa)free((void *)paraSepa);
		(void)fmtvalue(*pm, 1);
		paraSepa=strdup(*pm);
		}
	else msgShow(paraSepa);
	break;
  case ORL_path : {
	if(n>0){
	  sel=0;
	  static const char  *_pthchs="--cur";
	  ProcOpt opt={	1, NULL, &_pthchs,	&sel,	0, NULL, 0	};
	  arglists *alst=procParas(n, pm, &opt, NULL);
	  if( (i=alst->argc) ){
	     pt=(char *)alst->argv[0];
	     if(*pt=='*' && pt[1]==0)pt=(char *)SPC;
	     if(sel==0){ // only current system setting
		mau.buf=pt;  mau.len=strlen(pt);	mau.alen=mau.len+48;
		sysIdWrite(*workspace, PATH_ID, &mau);
		}
	     _env_path(*_argv, pt, &orlPaths);
	  }
	  argsFree(alst);
	  if(i==0)goto _shw_;
	}
	else _shw_: for(i=0; i<orlPaths.argc; i++)msgShow(orlPaths.argv[i]);
	}
	break;
  case ORL_log  : {
	char buf[48];
	msgShow("Detail see \"OpenRose.log\"");
	if((dir=DirOpen((__ORD *)*workspace, logChs))==NULL){
		static const un_Int preparm[pd_param_cnt]={  1, 10, 4, 1, 3 };
		strcpy(buf, logChs);
		dir=ORDcreat((__ORD *)*workspace, buf, preparm);
		}
	if(dir){
		char *lst[2];
		j=dir->selfnumbs;	i=0;
		ORDclose(dir, 2);
		lst[0]=buf;	lst[1]=NULL;
		while(i<j){
			(void)sprintf(buf,"/Log/%d", i++);
			NumSelect(workspace[0], lst, NULL,ORL_log);
		}
		(void)sprintf(buf, " %d records", i);
		msgShow(buf);
		if(logfp){
			fclose(logfp); logfp=NULL;
			}
	}
	}
	break;
  case ORL_mkdir : {
#define  mu1  3
 int dir1Val[mu1];
 static const char *dir1chs[mu1]={ "-z", "-t", "-c"},
  *_dir1chs[mu1]={"--zero", "--type", "--cd" };
 static const int dmk[mu1]={1, 2,  Ch_Dir /* over file no ask when creat rtl-file */};
#define  mu2  4
 int dir2Val[mu2];
 static const char *dir2chs[mu2]={ "-m", "-n", "-d", "-u" },
	*_dir2chs[mu2]={ "--mode", "--numpre", "--dirpre", "--unit" };
 ProcOpt opt1={	mu1,	dir1chs, _dir1chs,	dir1Val,	0, NULL, 0 },
  opt2={	mu2,	dir2chs, _dir2chs,	dir2Val,	0, NULL, 0	};
/*	*para=0; Format 
	para[1]=10;	n_stat_FCT   10 
	para[2]=4;	dir_stat_FCT  4 
	para[3]=dau, ignore = 1
	para[4]=1|2;  mode: RW  */
      un_Int param[pd_param_cnt];
      arglists *alst=fixPdPara(n, pm, &opt1, &opt2, dmk, param);
      if(alst){
	for(i=0; i<alst->argc; i++){
	  dir=ORDcreat(curlib->CurDir, (char *)alst->argv[i], param);
	  if(dir){
		if( *param&Ch_Dir ){
			curlib->bakdir_adr=curlib->CurDir->own_adr;
			goto _cd_;
			}
		if(dir->mode&ORL_OEM){
			msgShow(" OEM dir, can write any in this times");
		_cd_:	ORDclose(curlib->CurDir, 2);
			curlib->CurDir=dir;
			argsFree(alst);
			goto _dirinfo_;
			}
		ORDclose(dir, 0);
		}
	  else reportBug();
         }
         argsFree(alst);
       }
     }
      break;
  case ORL_find : ORDfind(send->CurDir, n, pm);
	break;
  case ORL_workspace :
 	if(n==0){
		for(i=0;i<SPACELIMIT;i++)
		    if(workspace[i])showWS(workspace[i]);
		break;
	}
  case ORL_open  :  send=openORL(send, n, pm, (3|4|32), ncmd);
	break;
  case ORL_exe :	send=exeScript(send, n, pm, 1, inpPath);
	break;
  case ORL_cd : 
	if(ORDchang(curlib, *pm, sel)){
	_dirinfo_:	if(diguei==0||runinginfo){
			ORDinfo(curlib->CurDir, OutBuf);
	_msg_show_:	msgShow(OutBuf);
		}
	}
	break;
  case ORL_info : _ws_info_: showWS(curlib);
		ORLinfo(curlib, OutBuf);
		msgShow(OutBuf);
	break;
  case ORL_rescue : NumUndel(curlib,*pm, 0);
	break;
  case ORL_rescues : for(numb=0;NumUndel(curlib,*pm,numb);numb++);
	if(getMsg){
		(void)sprintf(OutBuf, "Total <font color=#504040>%d</font> deleted numb be rescue", numb);
		goto _msg_show_;
		}
	else printf("Total \033[7m %d \033[0m deleted numb be rescue\n",numb);
	break;
  case ORL_ren :
  case ORL_erase : 
  case ORL_del  : if(adjNumb(*pm))goto oper_numb;
  case ORL_ndels :
  case ORL_empty :
  case ORL_rendir /* dir-rename */: 
  case ORL_rmdir /* only rm dir */:  ORDopera(curlib,pm,ncmd);
	break;
  case ORL_rm /* rm:only rm num */:
  case ORL_rename /* NumRename */: oper_numb: NumOpera(curlib,pm,ncmd);
	break;
  case ORL_rescudir : ORDundell(curlib,*pm);
	break;
  case ORL_cp : NumCopy(send,pm,extpara);
	break;
  case ORL_dircp :  ORDcopy(send, n, pm, extpara);
	break;
  case ORL_chdate :
  case ORL_chmode : chMT(curlib->CurDir, n, pm, ncmd);
	break;
  case ORL_numb :
  case ORL_ls : ORDlist(curlib->CurDir, n, pm, ncmd);
	break;
  case ORL_export : ORLexpo(curlib, n, pm, 0);
	break;
  case ORL_import : {
	char *pth;
	if(curlib==NULL)goto _import_;
	ORDchang(curlib, pm[1], sel);
	if(idxdscpt>0x7ffd){
	_import_:	pt=(char *)separChr(*pm);
		fn=pt ? catstr(*pm, pt, 0) : catstr(*pm, *pm, '/');
		pth=catstr(fn, RLS, 0);
		free((void *)fn);
		curlib=ORLscript(curlib, pth, 1, NULL);
		if(curlib)send=curlib;
		free(pth);
		}
	}
	break;
  case ORL_time : {
	unsigned char buf[8];
	ORtime(0, buf);
	msgShow(ORasctim(buf));
	}
	break;
  case ORL_clear :
	if(getMsg)getMsg(NULL);
	else {
		printf("\033[2J\033[1;1H");
		goto _dirinfo_;
	}
	break;
  case ORL_clrcom :
	if(getMsg)getMsg(SPC);
	break;
  case ORL_setdscpt : /* can be use extcmd, like setdscpt.o */ 
	putMAU(&mau,*pm,_txt/* type */);
	sysIdWrite(curlib, SCRIPT_ID/* 1*/, &mau);
    	break;
  case ORL_getdscpt :
	if( (pt=sysIdRead(curlib,1))!=NULL ){
		msgShow(pt);	free(pt);
		}
	break;
  case ORL_expoimg :  /*  ORD  to  os dir*/
	ORDimagas(curlib, n, pm);
	break;
#define flt  extpara
  case ORL_imagdir : 
	dir=ORDopen(curlib->CurDir, *pm, DIR_READ);
	if(dir && divFileName(pm[1], &flt)){
		pt=strrchr(pm[1], '/');
		if(pt)pt++;
		else pt=pm[1];
		__ORD *dir1=ORDuse(dir, pt);
		imagOD(dir1, pm[1], flt);
		ORDclose(dir1, 1);
		if(flt)free((void *)flt);
	}
	break;
  case ORL_osdirloop : 
	for(i=0; i<3; i++)fmtvalue(pm[i], True);
	if(divFileName(pm[2], &flt) ){
		DIR *dir=opendir(pm[2]);
		struct dirent *dent;
		int L;
		char **plst, buff[1600];
		pt=(char *)malloc(1024);
		j=0;	L=1024;
		while( (dent=readdir(dir)) ){
			fn=dent->d_name;
			if(strcmp(fn,".")==0 || strcmp(fn, "..")==0 || namefilters(fn,flt,1)==0 )continue;
			if(L-j<256){
				char *tmp;
				L+=1024;
				tmp=(char *)malloc(L);
				memcpy(tmp, pt, j);
				free(pt);
				pt=tmp;
				}
			n=sprintf(pt+j, "%s/", dent->d_name);
			j+=n;
		}
		pt[j-1]=0;
		n=80000;
		plst=setargv(pt, "/", &n);
		for(j=0; j<n; j++){
			for(i=j+1; i<n; i++)
				if(stricmp(plst[j], plst[i])>0){
					pt=plst[j];	plst[j]=plst[i];	plst[i]=pt;
					}
			fn=plst[j]; //dent->d_name;
			(void)sprintf(buff, pm[0], pm[1], pm[2], fn);
			comRun(curlib, buff, env, inpPath);
			}
		if(flt)free((void *)flt);
	}
	break;
#undef flt
  case ORL_remdscpt : 
	curlib->sys_Id_done=True;
	NumDel((__ORD *)curlib,SCRIPT_ID);
	curlib->sys_Id_done=False;
	break;
  case ORL_rbconf : 
	if(curlib==NULL)curlib=libhb;
	switch(n){
	case 0 : (void)sprintf(OutBuf, "limited size:%d K, limited persent:%d",curlib->CmprSiz,curlib->cmprPer);
		goto _msg_show_;
	case 2 : curlib->cmprPer=atoi(pm[1]);
	case 1 : curlib->CmprSiz=atoi(*pm);
		curlib->mdf|=1;
	}
	break;
  case ORL_ver : 
	if(getMsg){
		(void)sprintf(OutBuf, " &nbsp <font color=#000090>%s</font>\n &nbsp <font color=#900000>%s</font>", orlVer, orlKern);
		goto _msg_show_;
		}
	else printf("  \033[31m%s\n  \033[34m%s\033[0m\n",orlVer, orlKern);
		break;
  case ORL_os : 
	if(fork()==0)if(execvp(*pm, pm)!=0){
			(void)sprintf(OutBuf, failexe, *pm);
			goto _msg_show_;
			}
	break;
/*------------------------------------------------------------------*/
  case ORL_orlconf : /*  CONFIG_ID=3 */
  case ORL_orlinit : 
	if(n==0){ /* AUTORUN_ID=4 */
		if((pt=sysIdRead(*workspace, ncmd-ORL_orlconf+CONFIG_ID))!=NULL){
			msgShow(pt); free(pt);
			}
		}
	else {
		putMAU(&mau,*pm,_sold);
		sysIdWrite(*workspace, ncmd-ORL_orlconf+CONFIG_ID, &mau);
		}
	break;
  case ORL_setcfgval  :	setCfgVal(pm[0]);
	break;
  case ORL_arfile :
  case ORL_insert :
  case ORL_write /* write=insert.v */:
  case ORL_append : /* (curdir) */
  case ORL_add /* add otherdir*/: NumInsert(curlib->CurDir,n, pm, extpara, ncmd, env);/* env 0bit: append */
	break;
  case ORL_select :
  case ORL_read : if(n>2 && pm[1][0]=='>' && pm[1][1]==0){
			ncmd=ORL_readaward;
			outfn=pm[2];
			}
  case ORL_output : /* (to file:display.txt) */
	NumSelect(curlib, pm, extpara, ncmd);
	break;
  case ORL_releafile :
	releasAr(curlib, n, pm);
	break;
  case ORL_releadir :
	ORLexpo(curlib, n, pm, 1);
	break;
  case ORL_release : {
	fmtvalue(pm[0], 1);
	curlib=ORLopen(pm[0], FastBuf);
	if(curlib){
		ORLexpo(curlib, n-1, pm+1, 2);
		ORLclose(curlib, NULL);
		}
	}
	break;
/*------------------------------------------------------------------*/
  case ORL_txtdat : if(n<1){
			if(TDS){
				char buf[1024];
				sprintf(buf, "%s\nTxtDat : %u\n", TDS->fileRec, TDS->toluse);
				msgShow(buf);
			}
			else _tips3_ : msgShow("No TxtDat !");
			break;
		}
  case ORL_ztxtload :
  case ORL_txtload : if(TDS==NULL)TDS=(TxtDat *)zalloc(sizeof(TxtDat));
		CreatTD(TDS, *pm, 1|4, orlX, &orlPaths);
		goto _jmp3_;
  case ORL_ztxtimpor :
  case ORL_txtimpor : if(TDS==NULL)goto _tips3_;
  _jmp3_:  if(ncmd!=ORL_txtdat){
		__ORD *dir=DirOpen(curlib->CurDir, pm[ncmd/ORL_txtload]);
		if(idxdscpt>0x7ffd){
		  MAU mau[2];
		  fmtFCU fmt; //={ pmstat, numb, 0, 0 };
		  fmt.msg=0;	fmt.extVal=0;
		  if(ncmd!=ORL_ztxtload &&ncmd!=ORL_ztxtimpor)j=1;
		  else {
			seekFCU(dir,0,NULL,NUMB_LAST);
			fmt.numb=dir->NumbForZero-1;
			j=2;
		  }
		  for(i=0; i<TDS->toluse; i++){
			unsigned char pmstat[10]={ 0, 1|2, // mode
				0,0,0,0,0,0, // time
				_sold,  _sold };
			fmt.format=pmstat;
			switch(OverWrite){
			case 'q' : 
			case 4 :
			case 's' : 
			case 3 : /* X autoskip*/
			case Esc :
			case 0xfff0fff0 : goto _out2_;
			}
			memset(mau,0,sizeof(mau));
			if( j==1 ){
				fmt.numb=atol(TDS->oDat[i]);
				putMAU(mau,TDS->nDat[i],_sold);
			}
			else {	/* add,	zero */
				fmt.numb++;
				putMAU(mau,TDS->oDat[i],_sold);
				putMAU(mau+1,TDS->nDat[i],_sold);
				}
			wnfcu(dir, &fmt, mau, j);
		  }
		_out2_: ORDclose(dir, 1);
		}
	else defaultHB(idxdscpt);
	}
	break;
  case ORL_freetd : if(TDS){
			FreeTD(TDS, True);
			TDS=NULL;
		}
		else goto _tips3_;
	break;
  case ORL_rebuild : {
	static const char *_rb[2]={ "--verbose", "--fit" };
	int extval[2];
	memset(extval, 0, sizeof(int)*2);
	ProcOpt opt={ 2, NULL, _rb, extval, 0, NULL, 0	};
	arglists  *alst=procParas(n, pm, &opt, NULL);
	N=(extval[0] ? ShowTips : 0)|(extval[1] ? OptiFit : 0);
	i=0;
	if(alst->argc==0){
		if(curlib)goto _rebuild_;
		else { ORtips(I_None_58, 1); showUsage(ORL_rebuild); }
		}
	else {
	   while(i<alst->argc){
	_rebuild_:	curlib=ORLrebuild(curlib, alst->argc>0 ? alst->argv[i] : NULL, N );
		if( curlib  ){
			send=curlib;
			if(diguei==0||runinginfo){
				ORLinfo(curlib, OutBuf);
				msgShow(OutBuf);
				ORDinfo(curlib->CurDir, OutBuf);
				msgShow(OutBuf);
			}
		}
		i++;
	      }
	}
	argsFree(alst);
	}
	break;
  case ORL_closeall :
	for(i=1;i<SPACELIMIT;i++)if(workspace[i])ORLreleas(workspace[i], extDest);
	send=NULL;	break;
  case ORL_readme : ORtips(Readme_31, 0);
	break;
  case ORL_copyright :
	if(getMsg){
		(void)sprintf(OutBuf, " &nbsp <font color=#000080> %s </font>", copyRight);
		goto _msg_show_;
		}
	else printf(" \033[37;44;1m %s \033[0m \n", copyRight);
	break;
  case ORL_dir : {
	sel=0;
	static const char  *chs="-d", *_chs="--detail";
	ProcOpt opt={1,	&chs, &_chs,	&sel,	0,  NULL, 0	};
	arglists *alst=procParas(n, pm, &opt, NULL);
	if(alst->argc==0)ORDinfors(curlib->CurDir, OutBuf, sel&0xff);
	else for(i=0; i<alst->argc; i++ ){
		dir=DirOpen(curlib->CurDir, alst->argv[i]);
		if(idxdscpt>0x7ffd){
			ORDinfors(dir, OutBuf, sel&0xff);
			ORDclose(dir, 2);
		}
		else reportBug();
	     }
	argsFree(alst);
	}
  }// switch(ncmd)  end

_exit_:  if(lst)free(lst);
  return send;
}
